BITS 32
       ;**********************************************
       ;*                  CONSTANTES                *
       ;**********************************************
_pushad         equ 0x20
_eax            equ 0x1C
WM_PAINT        equ 0xF
WM_DESTROY      equ 2  
MB_OK           equ 0
WH_CALLWNDPROC  equ 4
       ;**********************************************
       ;*                    MACROS                  *
       ;**********************************************
       
%define prologue  esp+_pushad+4 
%define saut      0x0A,0xD

        ;**********************************************
        ;*                   IMPORTS                  *
        ;**********************************************
; -----------
;   hook
; ----------- 
extern HookProc    
import HookProc hook_fo1.dll   

extern Set_Handle_Hook
import Set_Handle_Hook hook_fo1.dll      

; -----------
;   Kernel32
; -----------
extern ExitProcess
import ExitProcess kernel32.dll

extern GetModuleHandleA
import GetModuleHandleA kernel32.dll

; -----------
;   User32
; -----------
extern MessageBoxA
import MessageBoxA user32.dll

extern SetWindowsHookExA
import SetWindowsHookExA user32.dll

extern UnhookWindowsHookEx
import UnhookWindowsHookEx user32.dll

 ; ------------------------------------------------------------------------------
 ; ------------------------------------------------------------------------------
  SEGMENT code USE32
 ; ------------------------------------------------------------------------------
 ; ------------------------------------------------------------------------------
 
        ;**********************************************
        ;*                    DATA                    *
        ;**********************************************
        
handle_window_hook  dd 0
handle_hook_dll     dd 0

erreur_titre        db 'Erreur !  :(',0
erreur_general      db "L'application n'a pas pu dmarrer.",0
hook_dll_name       db "hook_fo1.dll",0

attente_titre       db "Fallout 1 - ScreenRefresh",0
message             db "Appuyez sur le bouton OK pour arrter le rafrachissement."
                    db saut,saut
                    db "                          -= YoLeJedi - LABO =-",saut
                    db "                        http://www.labo-asso.com/",0                         

        ;**********************************************
        ;*                    CODE                    *
        ;**********************************************
        
;*****************************************************************************
;***************************************************************************** 
        
..start :
    
    push hook_dll_name
    call [GetModuleHandleA]     

    push 0
    push eax
    push dword [HookProc]
    push WH_CALLWNDPROC                      
    call [SetWindowsHookExA]
    or eax,eax
    je near .erreur
    mov [handle_window_hook], eax 
    
    push eax
    call [Set_Handle_Hook]    
    
    push 0         
    push attente_titre
    push message
    push 0
    call [MessageBoxA]    
    
    call close_all

.sortie :
    push 0
    call [ExitProcess]
    ret
    
.erreur :
    call close_all

    push 010h
    push erreur_titre
    push erreur_general
    push 0
    call [MessageBoxA]

    jmp .sortie
    
;*****************************************************************************
;*****************************************************************************    

close_all :
    pushad
        push dword [handle_window_hook]
        call [UnhookWindowsHookEx]
    popad
    ret
    
;*****************************************************************************
;*****************************************************************************    







